package com.chelvc.cloud.vehicle.server.service.impl;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.chelvc.cloud.vehicle.api.constant.CategoryType;
import com.chelvc.cloud.vehicle.api.dto.GoodsDTO;
import com.chelvc.cloud.vehicle.api.param.GoodsQueryParam;
import com.chelvc.cloud.vehicle.server.dao.GoodsMapper;
import com.chelvc.cloud.vehicle.server.entity.Goods;
import com.chelvc.cloud.vehicle.server.service.GoodsService;
import lombok.NonNull;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.util.CollectionUtils;

/**
 * 商品业务操作实现
 *
 * @author Woody
 * @date 2023/7/17
 */
@DubboService(interfaceClass = com.chelvc.cloud.vehicle.api.service.GoodsService.class)
public class GoodsServiceImpl extends ServiceImpl<GoodsMapper, Goods> implements GoodsService,
        com.chelvc.cloud.vehicle.api.service.GoodsService {
    @Override
    public List<CategoryType> listMerchantGoodsCategoryTypes(@NonNull Long merchantId) {
        List<CategoryType> types = this.baseMapper.listMerchantGoodsCategoryTypes(merchantId);
        if (!CollectionUtils.isEmpty(types)) {
            types.sort(CategoryType::compareTo);
        }
        return types;
    }

    @Override
    public List<GoodsDTO> listMerchantSimpleGoods(@NonNull Long merchantId, @NonNull GoodsQueryParam param) {
        return this.baseMapper.listMerchantSimpleGoods(merchantId, param);
    }
}
